@echo off

cd /d "%~d0" 1>nul 2>&1
cd "%~p0tool\" 1>nul 2>&1

set TDEDIR=%~dp0
call ..\setting\template\default_setting.bat
call ..\setting\user_setting.bat
call ..\setting\enc_setting.bat

:haru_test
set HARUMODE=false

if not exist "TEMP\HARU\haru_enc_start.bat" goto natsu_begin

set HARUMODE=true

if exist "TEMP\HARU\haru_enc_setting1.txt" (
  for /f "delims=" %%i in (TEMP\HARU\haru_enc_setting1.txt) do set ENDNOTICE=%%i
)
if exist "TEMP\HARU\haru_enc_setting2.txt" (
  for /f "delims=" %%i in (TEMP\HARU\haru_enc_setting2.txt) do set HARUTYPE=%%i
)
del /F "TEMP\HARU\haru_enc_start.bat" 1>nul 2>&1
del /F "TEMP\HARU\haru_enc_setting1.txt" 1>nul 2>&1
del /F "TEMP\HARU\haru_enc_setting2.txt" 1>nul 2>&1

:natsu_begin
color %BG_COLOR%
title %TDENC_TITLE%

if exist debug.txt (
   set DEBUG_MODE=true
   set KEEP_ERROR_REPORT=true
) else (
   set DEBUG_MODE=false
   set KEEP_ERROR_REPORT=false
)

rem ################[U[ݒǂݍ################
dir ".\" | findstr user_setting_template.bat>nul
IF ERRORLEVEL 1 goto zip_passed

call message_tsundere.bat
echo %UNZIP_ERROR1%
pause
call .\quit.bat

:zip_passed
dir ".\" | findstr version>nul
IF ERRORLEVEL 1 (
  echo %PATH_ERROR1%
  echo %PATH_ERROR2%
  pause
  start "ie" "http://www43.atwiki.jp/tdenc/pages/13.html"
  call .\quit.bat
)

dir ".\" | findstr 7z.exe>nul
IF ERRORLEVEL 1 (
  echo %ANTIVIRUS_ERROR1%
  echo %ANTIVIRUS_ERROR2%
  echo %ANTIVIRUS_ERROR3%
  pause
  call .\quit.bat
)
dir ".\" | findstr curl.exe>nul
IF ERRORLEVEL 1 (
  echo %ANTIVIRUS_ERROR1%
  echo %ANTIVIRUS_ERROR2%
  echo %ANTIVIRUS_ERROR3%
  pause
  call .\quit.bat
)

rem ################֘Ac[̃o[W`FbN֘A###############
if exist "%ProgramFiles(x86)%" (
  set XARCH=64bit
) else (
  set XARCH=32bit
)

call .\version.bat

if not "%PROXY%"=="" set PROXY=--proxy %PROXY%
set URL_PATH=".\tool_url.bat"

if "%DEBUG_MODE%"=="true" set DEFAULT_VERSION_CHECK=false

if /i "%DEFAULT_VERSION_CHECK%"=="true" (
  .\curl.exe -k %PROXY%  --connect-timeout 5 -f -o tool_url.zip -L "http://bit.ly/K1u07h" 2>nul
  if ERRORLEVEL 22 (
      set URL_PATH=".\tool_url_bk.bat"
  ) else (
      .\7z.exe e -bd -y ".\tool_url.zip" "tool_url.bat" 1>nul 2>&1
       copy /y tool_url.bat tool_url_bk.bat 1>nul 2>&1
  )
)

if "%DEBUG_MODE%"=="true" (
    .\curl.exe -k %PROXY%  --connect-timeout 5 -f -o tool_url.zip -L "http://bit.ly/MF9pnR" 2>nul
     .\7z.exe e -bd -y ".\tool_url.zip" "tool_url.bat" 1>nul 2>&1
      copy /y tool_url.bat tool_url_bk.bat 1>nul 2>&1
)

call %URL_PATH%

set /a TVER=%THIS_VERSION%
if %TVER% LEQ 17 set THIS_VERSION=%PRESET_VERSION%

if not "%THIS_VERSION%"=="%PRESET_VERSION%" (
    echo ^>^>%PRESET_ALERT%
    echo;
    call .\quit.bat
)

rem ################o[WvZbg\################
echo %HORIZON%
echo @%TDENC_NAME%  version %C_VERSION% %TDENC_NAME2%
echo %HORIZON%
echo @@preset : version %THIS_VERSION%
echo %HORIZON%

rem ################tH_쐬################
rem ꎞt@CۑtH_ύXƂ͂MĂ
rem AGRɈꎞt@CSč폜̂Ō쓮|ꍇ͘MȂł
set TEMP_DIR0=TEMP

if not exist %TEMP_DIR0% mkdir %TEMP_DIR0%
if not exist %MP4_DIR% mkdir %MP4_DIR%

rem ################o[W`FbN################
if /i "%DEFAULT_VERSION_CHECK%"=="true" (
    call .\version_check.bat
)
if /i "%VERSION_UP%"=="y" goto :eof

call ..\setting\x264_common.bat
if "%USER_XCOMMON%"=="" (
  move /Y ..\setting\x264_common.bat ..\setting\x264_common_old.bat
  copy ..\setting\template\x264_common_template.bat ..\setting\x264_common.bat
  call ..\setting\x264_common.bat
)
if exist ..\setting\x264_common_new.bat del ..\setting\x264_common_new.bat

call ..\setting\x\high.bat
if "%USER_PRESETX%"=="" (
  move /Y ..\setting\x\high.bat ..\setting\x\high_old.bat
  copy ..\setting\x\high_template.bat ..\setting\x\high.bat
  call ..\setting\x\high.bat
)
set CRF=
if exist ..\setting\x\high_new.bat del ..\setting\x\high_new.bat

rem user_setting.bat̍XV
if "%ENC_VERSION%"=="%THIS_VERSION%" (
  if "%USER_XCOMMON%"=="%XCOMMON_VERSION%" (
    if "%USER_PRESETX%"=="%PRESETX_VERSION%" (
      if "%USER_VERSION%"=="%CUSTOM_VERSION%" (
        goto user_setting_update_end
      )
    )
  )
)
:user_setting_update
echo;
echo ^>^>%USER_SETTING1%
echo ^>^>%USER_SETTING2%
set /p USER_UPDATE=^>^>
if /i "%USER_UPDATE%"=="y" (
    if not "%ENC_VERSION%"=="%THIS_VERSION%" (
      move /Y ..\setting\enc_setting.bat ..\setting\enc_setting_old.bat
      copy ..\setting\template\enc_setting_template.bat ..\setting\enc_setting.bat
      call ..\setting\enc_setting.bat
    )
    if not "%USER_VERSION%"=="%CUSTOM_VERSION%" (
      move /Y ..\setting\user_setting.bat ..\setting\user_setting_old.bat
      copy ..\setting\template\user_setting_template.bat ..\setting\user_setting.bat
      call ..\setting\user_setting.bat
    )
    if not "%USER_XCOMMON%"=="%XCOMMON_VERSION%" (
      move /Y ..\setting\x264_common.bat ..\setting\x264_common_old.bat
      copy ..\setting\template\x264_common_template.bat ..\setting\x264_common.bat
    )
    if not "%USER_PRESETX%"=="%PRESETX_VERSION%" (
      move /Y ..\setting\x\high.bat ..\setting\x\high_old.bat
      copy ..\setting\x\high_template.bat ..\setting\x\high.bat
    )
) else if /i "%USER_UPDATE%"=="n" (
    echo ^>^>%PRESET_ALERT2%
    echo ^>^>%PAUSE_MESSAGE1%
    pause>nul
) else (
    echo ^>^>%RETURN_MESSAGE1%
    goto user_setting_update
)
if "%DEFAULT_SIZE_YOUTUBE_PARTNER%"=="" (
    echo ^>^>%USER_SETTING1%
    echo ^>^>%PRESET_ALERT3%
)
echo;
:user_setting_update_end


if exist ..\setting\*_template.bat del /Q ..\setting\*_template.bat
if exist ..\setting\default_setting.bat del ..\setting\default_setting.bat

rem ################c[ނ̐ݒ################
call :file_exist_check

rem ################ÂTEMPtH_̍폜ƐVTEMPtH_̍쐬################
if "%DEBUG_MODE%"=="true" (
  set FOLDER_LIMIT=10
  goto delete_temp
)
set FOLDER_LIMIT=5

ver | findstr "4. 5.0 5.1">nul
if ERRORLEVEL 1 (
  forfiles /P %TEMP_DIR0% /D -7 /C "cmd /c if @isdir==TRUE rmdir /S /Q @path" 1>nul 2>&1
  goto make_temp
)

:delete_temp
dir /b /ad %TEMP_DIR0% | find /c /v ""> temp.txt
for /f "delims=" %%i in (temp.txt) do set /a NTEMP=%%i
if %NTEMP% LEQ %FOLDER_LIMIT% goto make_temp

echo ^>^>%DELTEMP1%
echo ^>^>%DELTEMP2%
set /p DTEMP=^>^>
if /i "%DTEMP%"=="y" rmdir /s /q %TEMP_DIR0%
del temp.txt

:make_temp
for /f "usebackq tokens=*" %%i in (`.\date +%%Y%%m%%d`) do set FDATE=%%i
for /f "usebackq tokens=*" %%i in (`.\date +%%H%%M%%S`) do set FTIME=%%i
set TEMP_DIR=%TEMP_DIR0%\%FDATE%-%FTIME%
mkdir %TEMP_DIR%

rem ################ϐݒ################
set TEMP_INFO=%TEMP_DIR%\temp.txt
set TEMP_INFO2=%TEMP_DIR%\temp2.txt
set TEMP_INFO3=%TEMP_DIR%\temp3.txt
set INFO_AVS=%TEMP_DIR%\information.avs
set INFO_AVS3=%TEMP_DIR%\information3.avs
set PROCESS_S_FILE=%TEMP_DIR%\proccess.txt
set PROCESS_E_FILE=%TEMP_DIR%\end.txt
set VIDEO_AVS=%TEMP_DIR%\video.avs
set AUDIO_AVS=%TEMP_DIR%\audio.avs
set AUDIO_AVS2=%TEMP_DIR%\audio2.avs
set TEMP_264=%TEMP_DIR%\video.264
set TEMP_WAV=%TEMP_DIR%\audio.wav
set TEMP_WAV2=%TEMP_DIR%\audio2.wav
set TEMP_M4A=%TEMP_DIR%\audio.m4a
set FINAL_WAV=%TEMP_DIR%\audio_repair.wav
set TEMP_MP4=%TEMP_DIR%\movie.mp4
set TEMP_AVI=movie.avi
set TEMP_FLV=%TEMP_DIR%\movie.flv
set ENC_RECORD=..\setting\beginner_enc_record.txt
set CHANGE_AUTO_BR_LIMIT=false
set BEGINNER=false
set CRFMODE=n
set VFR=false
set SILENT=false
set ENC_MODE=
set MAKEFLV=n
set DATACOPY=n
set SIZEOK=n
set AUTOBITRATEOFF=n
set FORCERESIZE=n
set PRESET_S_ENABLE=n
set FFPIPE=false
set /a CONST_WIDERATIO=5625
set /a MAX_BR_RECORD=0
set /a INPUT_A_BIT_RATE=0
set /a S_V_BITRATE=0
set /a ME_BITRATE=0
set /a MS_BITRATE=1000
set /a CURRENT_BITRATE=1000
rem set /a I_MAX_BITRATE=%I_MAX_BITRATE%

rem ################WXg`FbN################
rem call :registry_check

rem ################A`EBX`FbN################
(
    echo BlankClip^(length=1, width=32, height=32^)
    echo;
    echo _start_date = String^( %FDATE% ^)
    echo _start_time = String^( -%FTIME% ^)
    echo WriteFileStart^("time_start.txt","_start_date", "_start_time",append = false^)
    echo;
    echo return last
)> %INFO_AVS%

.\avs2pipemod.exe -info %INFO_AVS% 1>nul 2>&1
if not exist %TEMP_DIR%\time_start.txt (
   echo;
   echo %ANTIVIRUS_ERROR4%
   echo %ANTIVIRUS_ERROR5%
   echo;
   call .\quit.bat
)

rem ################GR[h[h################
if "%~1"=="" goto file_drop_mode

if "%~1"=="" (
    echo;
    echo ^>^>%DOUBLECLICK_ALERT1%
    echo ^>^>%DOUBLECLICK_ALERT2%
    echo;
    call .\quit.bat
)

dir "%~1" | findstr \^<\.$>nul
if ERRORLEVEL 1 (
  if /i "%SHORTNAME%"=="true" goto filename_check_skip
)

:filename_check
set ALL_ARGUMENTS=%*
set ALL_ARGUMENTS_CMD0="%ALL_ARGUMENTS:"=%"
set ALL_ARGUMENTS_CMD1=%ALL_ARGUMENTS_CMD0:&=?%
set ALL_ARGUMENTS_CMD2=%ALL_ARGUMENTS_CMD1:"=%
echo %ALL_ARGUMENTS_CMD2%> %TEMP_INFO%
for /f "delims=" %%i in (%TEMP_INFO%) do set ALL_ARGUMENTS_TXT=%%i
if not %ALL_ARGUMENTS_CMD0%=="%ALL_ARGUMENTS_TXT%" (
    echo ^<List1^>
    echo   %ALL_ARGUMENTS_CMD0%
    echo ^<List2^>
    echo   "%ALL_ARGUMENTS_TXT%"
    echo;
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR2%
    echo;
    set FILENAME_ERROR_FOUND=y
    call .\quit.bat
)

:filename_check_skip
echo "%~n1"> %TEMP_INFO%
for /f "delims=" %%i in (%TEMP_INFO%) do set FINAL_FILE=%%~i
if not "%~n1"=="%FINAL_FILE%" set FINAL_FILE=%FILENAME_ERROR_MP4%

if not "%~3"=="" goto sequence_mode
if not "%~2"=="" (
  if not "%~2"=="%~1" goto mux_mode
)
rem 1t@C̃GR[h
dir "%~1" | findstr \^<\.$>nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%UNITE_AVI_ANNOUNCE1%
    echo ^>^>%UNITE_AVI_ANNOUNCE2%
    echo ^>^>"%~1" %PROCESS_ANNOUNCE%
    echo;
    call :cat_avi "%~1"
    set ERROR_REPORT="%MP4_DIR%\%FINAL_FILE%_error_report.txt"
    copy /y error_report_template.txt %ERROR_REPORT% 1>nul 2>&1
    call .\cat.bat
    call :temp_264_check
    call .\create_mp4.bat
    call .\shut.bat
)

echo ^>^>%ONE_MOVIE_ANNOUNCE%
echo ^>^>"%~1" %PROCESS_ANNOUNCE%
echo;

:one_movie_mode
set INPUT_FILE_TYPE=%~x1
if /i "%SHORTNAME%"=="true" (
  set INPUT_FILE_PATH="%~s1"
) else (
  set INPUT_FILE_PATH="%~1"
)
set ORIGINAL_VIDEO="%~1"
set ORIGINAL_AUDIO="%~1"

:one_movie_mode_main
set ENC_MODE=ONEMOVIE
set INPUT_VIDEO=%INPUT_FILE_PATH%
set INPUT_AUDIO=%INPUT_FILE_PATH%
set FINAL_MP4=%FINAL_FILE%.mp4
set ERROR_REPORT="%MP4_DIR%\%FINAL_FILE%_error_report.txt"
copy /y error_report_template.txt %ERROR_REPORT% 1>nul 2>&1

if not exist %INPUT_FILE_PATH% (
    echo %INPUT_FILE_PATH%
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR3%
    call .\quit.bat
)

echo %INPUT_FILE_TYPE% | findstr /i "mswmm wlmp aup vsp">nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%PROJECTFILE_ERROR1%
    if "%INPUT_FILE_TYPE%"==".mswmm" echo ^>^>%PROJECTFILE_ERROR2% 
    if "%INPUT_FILE_TYPE%"==".wlmp" echo ^>^>%PROJECTFILE_ERROR3% 
    if "%INPUT_FILE_TYPE%"==".aup" echo ^>^>%PROJECTFILE_ERROR4% 
    call .\quit.bat
)

if /i "%DECODER%"=="auto" call :codec_check "%~1"
if /i "%DECODER%"=="avi" (
    call :normal_main
    call .\shut.bat
)
if /i "%DECODER%"=="qt" (
    call :normal_main
    call .\shut.bat
)
if /i "%DECODER%"=="directshow" (
    call :normal_main
    call .\shut.bat
)
if /i "%DECODER%"=="ffmpeg" (
    call :normal_main
    call .\shut.bat
)
echo %INPUT_FILE_TYPE% | findstr /i "mkv wmv asf flv mp4 mov dv mpg">nul
if "%ERRORLEVEL%"=="0" (
    set DECODER=ffmpeg
    call :normal_main
    call .\shut.bat
)
if /i "%INPUT_FILE_TYPE%"==".avi" (
    set DECODER=avi
) else (
    set DECODER=directshow
)

call :normal_main
call .\shut.bat

rem t@C̘AGR[h
:sequence_mode
echo ^>^>%SEQUENCE_ANNOUNCE%
echo;
:sequence_start
if "%~1"=="" goto sequence_end

echo ^>^>"%~1" %PROCESS_ANNOUNCE%
echo;

set INPUT_FILE_TYPE=%~x1
if /i "%SHORTNAME%"=="true" (
  set INPUT_FILE_PATH="%~s1"
) else (
  set INPUT_FILE_PATH="%~1"
)
set INPUT_VIDEO=%INPUT_FILE_PATH%
set INPUT_AUDIO=%INPUT_FILE_PATH%
set ORIGINAL_VIDEO="%~1"
set ORIGINAL_AUDIO="%~1"
set ENC_MODE=SEQUENCE

if not exist %INPUT_FILE_PATH% (
    echo %INPUT_FILE_PATH%
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR3%
    call .\quit.bat
)

echo %INPUT_FILE_TYPE% | findstr /i "mswmm wlmp aup vsp">nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%PROJECTFILE_ERROR1%
    if "%INPUT_FILE_TYPE%"==".mswmm" echo ^>^>%PROJECTFILE_ERROR2% 
    if "%INPUT_FILE_TYPE%"==".wlmp" echo ^>^>%PROJECTFILE_ERROR3% 
    if "%INPUT_FILE_TYPE%"==".aup" echo ^>^>%PROJECTFILE_ERROR4% 
    call .\quit.bat
)

echo "%~n1"> %TEMP_INFO%
for /f "delims=" %%i in (%TEMP_INFO%) do set FINAL_FILE=%%~i
if not "%~n1"=="%FINAL_FILE%" set FINAL_FILE=%FILENAME_ERROR_MP4%

set FINAL_MP4=%FINAL_FILE%.mp4
set ERROR_REPORT="%MP4_DIR%\%FINAL_FILE%_error_report.txt"
copy /y error_report_template.txt %ERROR_REPORT% 1>nul 2>&1

if /i "%DECODER%"=="auto" call :codec_check "%~1"
if /i "%DECODER%"=="avi" (
    goto ext_check
)
if /i "%DECODER%"=="qt" (
    goto ext_check
)
if /i "%DECODER%"=="directshow" (
    goto ext_check
)
if /i "%DECODER%"=="ffmpeg" (
    goto ext_check
)
echo %INPUT_FILE_TYPE% | findstr /i "mkv wmv asf flv mp4 mov dv mpg">nul
if "%ERRORLEVEL%"=="0" (
    set DECODER=ffmpeg
    goto ext_check
)

if /i "%INPUT_FILE_TYPE%"==".avi" (
    set DECODER=avi
) else (
    set DECODER=directshow
)

:ext_check
if "%INPUT_FILE_TYPE%"=="" (
    echo ^>^>%MOVIE_INFO_ERROR1%
    echo ^>^>%MOVIE_INFO_ERROR2%
    echo;
    echo %MOVIE_INFO_ERROR3%
    echo %MOVIE_INFO_ERROR4%
    echo;
    echo ^>^>%PAUSE_MESSAGE1%
    pause>nul
    call .\quit.bat
)

call :normal_main

echo;
shift

if "%KEEP_WAV%"=="y" (
 if exist %TEMP_WAV% (
     move /y %TEMP_WAV% "%MP4_DIR%\%FINAL_FILE%.wav" 1>nul 2>&1
 ) else (
     move /y %FINAL_WAV% "%MP4_DIR%\%FINAL_FILE%.wav" 1>nul 2>&1
 )
)

if exist %TEMP_DIR% rmdir /s /q %TEMP_DIR%
mkdir %TEMP_DIR%

set FFPIPE=false

goto sequence_start

:sequence_end
echo;
echo ^>^>%SEQUENCE_END1%
echo ^>^>%SEQUENCE_END2%
echo ^>^>%SEQUENCE_END3%
echo;
echo ^>^>%PAUSE_MESSAGE2%
pause>nul
call .\shut.bat


rem ƂMUXGR[h
:mux_mode
echo;
echo "%~x2" | findstr /i "wav mp3">nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%MUX_ANNOUNCE%
    if /i "%SHORTNAME%"=="true" (
       set INPUT_AUDIO="%~s2"
       set INPUT_VIDEO="%~s1"
    ) else (
       set INPUT_AUDIO="%~2"
       set INPUT_VIDEO="%~1"
    )
    set INPUT_FILE_TYPE=%~x1
    set INPUT_AUDIO_TYPE=%~x2
    set ORIGINAL_VIDEO="%~1"
    set ORIGINAL_AUDIO="%~2"
    echo ^>^>%MOVIE_FILE_ANNOUNCE% "%~1" %PROCESS_ANNOUNCE%
    echo ^>^>%AUDIO_FILE_ANNOUNCE% "%~2" %PROCESS_ANNOUNCE%
    goto mux_encode_start
)

echo "%~x1" | findstr /i "wav mp3">nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%MUX_ANNOUNCE%
    if /i "%SHORTNAME%"=="true" (
       set INPUT_AUDIO="%~s1"
       set INPUT_VIDEO="%~s2"
    ) else (
       set INPUT_AUDIO="%~1"
       set INPUT_VIDEO="%~2"
    )
    set INPUT_FILE_TYPE=%~x2
    set INPUT_AUDIO_TYPE=%~x1
    set ORIGINAL_VIDEO="%~2"
    set ORIGINAL_AUDIO="%~1"
    echo ^>^>%MOVIE_FILE_ANNOUNCE% "%~2" %PROCESS_ANNOUNCE%
    echo ^>^>%AUDIO_FILE_ANNOUNCE% "%~1" %PROCESS_ANNOUNCE%
) else (
    goto sequence_mode
)

echo "%~n2"> %TEMP_INFO%
for /f "delims=" %%i in (%TEMP_INFO%) do set FINAL_FILE=%%~i
if not "%~n2"=="%FINAL_FILE%" set FINAL_FILE=%FILENAME_ERROR_MP4%

:mux_encode_start
if not exist %INPUT_VIDEO% (
    echo %INPUT_VIDEO%
    echo %INPUT_AUDIO%
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR3%
    call .\quit.bat
)
if not exist %INPUT_AUDIO% (
    echo %INPUT_VIDEO%
    echo %INPUT_AUDIO%
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR3%
    call .\quit.bat
)

echo %INPUT_FILE_TYPE% | findstr /i "jpg jpeg png bmp">nul
if "%ERRORLEVEL%"=="1" (
  set ENC_MODE=MOVIEMUX
) else (
  set ENC_MODE=IMAGEMUX
)

echo %INPUT_FILE_TYPE% | findstr /i "mswmm wlmp aup vsp">nul
if "%ERRORLEVEL%"=="0" (
    echo ^>^>%PROJECTFILE_ERROR1%
    if "%INPUT_FILE_TYPE%"==".mswmm" echo ^>^>%PROJECTFILE_ERROR2% 
    if "%INPUT_FILE_TYPE%"==".wlmp" echo ^>^>%PROJECTFILE_ERROR3% 
    if "%INPUT_FILE_TYPE%"==".aup" echo ^>^>%PROJECTFILE_ERROR4% 
    call .\quit.bat
)

set FINAL_MP4=%FINAL_FILE%.mp4
set FINAL_FLV=%FINAL_FILE%.flv
set ERROR_REPORT="%MP4_DIR%\%FINAL_FILE%_error_report.txt"
copy /y error_report_template.txt %ERROR_REPORT% 1>nul 2>&1

call :mux_filetype_check
call .\mux.bat
call :temp_264_check
call .\create_mp4.bat
call .\shut.bat

rem ################֐ۂ################
:file_exist_check
if not exist Avisynth.dll  start /wait call initialize.bat
if not exist avs2avi.exe  start /wait call initialize.bat
if not exist avs2pipemod.exe  start /wait call initialize.bat
if not exist date.exe start /wait call initialize.bat
if not exist DirectShowSource.dll  start /wait call initialize.bat
if not exist DevIL.dll start /wait call initialize.bat
if not exist ffmpeg.exe  start /wait call initialize.bat
if not exist ffms2.dll start /wait call initialize.bat
if not exist ffmsindex.exe start /wait call initialize.bat
if not exist libiconv2.dll  start /wait call initialize.bat
if not exist libintl3.dll  start /wait call initialize.bat
if not exist MP4Box.exe start /wait call initialize.bat
if not exist MediaInfo.exe start /wait call initialize.bat
if not exist MediaInfo.dll start /wait call initialize.bat
if not exist mp4fpsmod.exe start /wait call initialize.bat
if not exist neroAacEnc.exe start /wait call initialize.bat
if not exist pcre3.dll  start /wait call initialize.bat
if not exist player.swf  start /wait call initialize.bat
if not exist playwav.exe  start /wait call initialize.bat
if not exist qaac.exe  start /wait call initialize.bat
rem if not exist qtaacenc.exe  start /wait call initialize.bat
if not exist QTSource.dll start /wait call initialize.bat
if not exist regex2.dll  start /wait call initialize.bat
if not exist sed.exe start /wait call initialize.bat
if not exist sort.exe start /wait call initialize.bat
if not exist yadif.dll start /wait call initialize.bat
if not exist %X264EXE% start /wait call initialize.bat
.\%X264EXE% --version>"%TEMP_DIR0%\x264_version.txt" 2>nul
rem findstr /i "%X264_VERSION%" "%TEMP_DIR0%\x264_version.txt">nul 2>&1
rem if "%ERRORLEVEL%"=="1" start /wait call initialize.bat

if not exist "%TEMP_DIR0%\x264_version.txt" (
   echo;
   echo %ANTIVIRUS_ERROR4%
   echo %ANTIVIRUS_ERROR5%
   echo;
   call .\quit.bat
)

exit /b

:codec_check
.\MediaInfo.exe --Inform=Video;%%Codec%% --LogFile=%TEMP_INFO% %1>nul
findstr /i "dv mpeg" "%TEMP_INFO%">nul 2>&1
if "%ERRORLEVEL%"=="0" (
    set DECODER=ffmpeg
    exit /b
)
.\MediaInfo.exe --Inform=Video;%%Codec/CC%% --LogFile=%TEMP_INFO% %1>nul
findstr /i "cvid msvc cram" "%TEMP_INFO%">nul 2>&1
if "%ERRORLEVEL%"=="0" (
    set DECODER=ffmpeg
    exit /b
)
.\MediaInfo.exe --Inform=Video;%%CodecID%% --LogFile=%TEMP_INFO% %1>nul
findstr /i "xtor" "%TEMP_INFO%">nul 2>&1
if "%ERRORLEVEL%"=="0" (
    set DECODER=directshow
    exit /b
)

exit /b

:cat_avi
set CAT_DIR=%~1
set CAT_AVI_LIST1=%TEMP_DIR%\cat_avi1.txt
set CAT_AVI_LIST2=%TEMP_DIR%\cat_avi2.txt
set CAT_WAV1=%TEMP_DIR%\cat_wav1.txt
set CAT_WAV2=%TEMP_DIR%\cat_wav2.txt
set INPUT_FILE_PATH="%CAT_DIR%\%FINAL_FILE%.avs"
set INPUT_VIDEO=%INPUT_FILE_PATH%
set INPUT_AUDIO=%INPUT_FILE_PATH%
set INPUT_FILE_TYPE=.avs
set FINAL_MP4=%FINAL_FILE%.mp4
dir /b /on "%CAT_DIR%" | findstr /i .avi$> %CAT_AVI_LIST1%
.\sort.exe -n "%CAT_AVI_LIST1%" -o "%CAT_AVI_LIST2%"
dir /b "%CAT_DIR%" | findstr /i .wav$> %CAT_WAV1%
.\sort.exe -n "%CAT_WAV1%" -o "%CAT_WAV2%"
for /f "delims=" %%i in (%CAT_WAV2%) do set CAT_WAV_PATH=%%i
for %%i in (%CAT_WAV2%) do (
   set /p INPUT_WAV1=<"%%~i"
)
(
    if not "%CAT_WAV_PATH%"=="" (
        echo AudioDub^(AVISource^(^\
    ) else (
        echo AVISource^(^\
    )
    for /f "delims=" %%i in (%CAT_AVI_LIST2%) do echo "%%i", ^\
    if "%CAT_WAV_PATH%"=="" (
        echo audio = true^)
    ) else (
        echo audio = false^),WAVSource^(^\
        echo "%INPUT_WAV1%" ^\
        for /f "skip=1 delims=" %%i in (%CAT_WAV2%) do echo , "%%i" ^\
        echo ^)^)
    )
    echo;
    echo return last
    )> %INPUT_FILE_PATH%
)
exit /b

:normal_main
if /i "%INPUT_FILE_TYPE%"==".avs" (
    call .\avs.bat
    call :temp_264_check
    call .\create_mp4.bat
    exit /b
)
if /i "%INPUT_FILE_TYPE%"==".nvv" (
    echo ^>^>%NVV_ALERT%
    call .\quit.bat
)
if /i "%INPUT_FILE_TYPE%"==".swf" (
    echo ^>^>%SWF_ALERT%
    call .\quit.bat
)
call .\movie.bat
call :temp_264_check
call .\create_mp4.bat
exit /b

:mux_filetype_check
if /i "%DECODER%"=="auto" call :codec_check %INPUT_VIDEO%
if /i "%INPUT_FILE_TYPE%"==".nvv" (
    echo ^>^>%MUX_ALERT1%
    echo ^>^>%MUX_ALERT2%
    echo;
    call .\quit.bat
)
if /i not "%DECODER%"=="auto" exit /b
echo %INPUT_FILE_TYPE% | findstr /i "mkv wmv asf flv mp4 mov dv">nul
if "%ERRORLEVEL%"=="0" (
    set DECODER=ffmpeg
    exit /b
)
if /i "%INPUT_FILE_TYPE%"==".avi" (
    set DECODER=avi
) else (
    set DECODER=directshow
)
exit /b

:temp_264_check
if not exist %TEMP_264% (
    echo ^>^>%VIDEO_ENC_ERROR%
    echo;
    echo ^>^>%PAUSE_MESSAGE1%
    pause>nul
    goto :eof
)
exit /b

:file_drop_mode
echo;
echo ^>^>%FILE_DROP1%
echo ^>^>%FILE_DROP5%
echo ^>^>%FILE_DROP4%
set /P INPUT_VIDEO=
if "%INPUT_VIDEO%"=="" goto file_drop_mode
:file_drop_mode2
echo;
echo ^>^>%FILE_DROP2%
echo ^>^>%FILE_DROP3%
echo ^>^>%FILE_DROP5%
echo ^>^>%FILE_DROP4%
set /P INPUT_AUDIO=
if "%INPUT_AUDIO%"=="" goto file_drop_mode2

if not "%INPUT_VIDEO%"=="%INPUT_AUDIO%" goto mux_mode_setup
if "%INPUT_VIDEO%"=="" goto file_drop_mode
set INPUT_FILE_PATH="%INPUT_VIDEO%"
echo %INPUT_FILE_PATH%> %TEMP_INFO%
for /f "tokens=*" %%I in (%TEMP_INFO%) do set INPUT_FILE_TYPE=%%~xI
for /f "tokens=*" %%I in (%TEMP_INFO%) do set FINAL_FILE=%%~nI
for /f "tokens=*" %%I in (%TEMP_INFO%) do set ALL_ARGUMENTS_TXT=%%~fI
if not exist "%ALL_ARGUMENTS_TXT%" (
    echo ^<List1^>
    echo   "%INPUT_VIDEO%"
    echo ^<List2^>
    echo   "%ALL_ARGUMENTS_TXT%"
    echo;
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR2%
    echo;
    set FILENAME_ERROR_FOUND=y
    call .\quit.bat
)
set ORIGINAL_VIDEO="%INPUT_VIDEO%"
set ORIGINAL_AUDIO="%INPUT_VIDEO%"
goto one_movie_mode_main

:mux_mode_setup
echo ^>^>%MUX_ANNOUNCE%
set INPUT_VIDEO="%INPUT_VIDEO%"
echo %INPUT_VIDEO%> %TEMP_INFO%
for /f "delims= tokens=*" %%I in (%TEMP_INFO%) do set INPUT_FILE_TYPE=%%~xI
for /f "delims= tokens=*" %%I in (%TEMP_INFO%) do set FINAL_FILE=%%~nI
for /f "tokens=*" %%I in (%TEMP_INFO%) do set ALL_ARGUMENTS_TXT=%%~fI
if not exist "%ALL_ARGUMENTS_TXT%" (
    echo ^<List1^>
    echo   "%INPUT_VIDEO%"
    echo ^<List2^>
    echo   "%ALL_ARGUMENTS_TXT%"
    echo;
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR2%
    echo;
    set FILENAME_ERROR_FOUND=y
    call .\quit.bat
)
set INPUT_AUDIO="%INPUT_AUDIO%"
echo %INPUT_AUDIO%> %TEMP_INFO%
for /f "delims= tokens=*" %%I in (%TEMP_INFO%) do set INPUT_AUDIO_TYPE=%%~xI
for /f "delims= tokens=*" %%I in (%TEMP_INFO%) do set ALL_ARGUMENTS_TXT=%%~fI
if not exist "%ALL_ARGUMENTS_TXT%" (
    echo ^<List1^>
    echo   "%INPUT_AUDIO%"
    echo ^<List2^>
    echo   "%ALL_ARGUMENTS_TXT%"
    echo;
    echo ^>^>%FILENAME_ERROR1%
    echo ^>^>%FILENAME_ERROR2%
    echo;
    set FILENAME_ERROR_FOUND=y
    call .\quit.bat
)
set ORIGINAL_VIDEO=%INPUT_VIDEO%
set ORIGINAL_AUDIO=%INPUT_AUDIO%
echo ^>^>%MOVIE_FILE_ANNOUNCE% %INPUT_VIDEO% %PROCESS_ANNOUNCE%
echo ^>^>%AUDIO_FILE_ANNOUNCE% %INPUT_AUDIO% %PROCESS_ANNOUNCE%
goto mux_encode_start

exit /b

:registry_check
if exist %WINDIR%\system32\avisynth.dll exit /b
if exist %WINDIR%\SysWow64\avisynth.dll exit /b
if "%XRACH%"=="64bit" GOTO reg-X64
regedit /s "install.reg">nul
reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\CLSID\{E6D6B700-124D-11D4-86F3-DB80AFD98778}"> %TEMP_DIR%\registory.txt 2>nul
GOTO reg-Suc

:reg-X64
regedit /s "installx64.reg">nul
reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Classes\CLSID\{E6D6B700-124D-11D4-86F3-DB80AFD98778}"> %TEMP_DIR%\registory.txt 2>nul

:reg-Suc
findstr /i "Avisynth" "%TEMP_DIR%\registory.txt">nul
if "%ERRORLEVEL%"=="0" exit /b
echo ^>^>%AVS_ERROR1%
echo ^>^>%AVS_ERROR2%
echo ^>^>%AVS_ERROR3%
echo;
echo ^>^>%PAUSE_MESSAGE1%
pause>nul
call .\quit.bat
exit /b

rem ################ł񂱏I..._(߁ )ˬ################
